import { world, system } from '@minecraft/server';

// Definir los cultivos y sus estados máximos de crecimiento
const cebolla = 'tfu:cebolla';
const lechuga = 'tfu:lechuga';
const maiz = 'tfu:maiz';
const tomate = 'tfu:tomate';

// Definir los estados máximos para cada cultivo
const cebollaMaxAge = 3;
const lechugaMaxAge = 3;
const maizMaxAge = 3;
const tomateMaxAge = 6;

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('tfu:grow', {

        tickInterval: 10,

        onPlayerInteract(e) {
            const block = e.block;
            const player = e.player;

            const blockPos = block.location;
            const age = block.permutation.getState('tfu:age');
            if (player.hasTag("bone_meal")) {
                const age = block.permutation.getState('tfu:age');
                const blockPos = block.location;

                // Generar un número aleatorio para determinar si la acción se ejecuta
                const randomChance = Math.random();

                // Crecimiento de Cebolla
                if (block.typeId == cebolla && age < cebollaMaxAge) {
                    if (randomChance < 0.75) {
                        block.setPermutation(block.permutation.withState('tfu:age', age + 1));
                        player.runCommandAsync(`particle minecraft:crop_growth_emitter ${blockPos.x} ${blockPos.y} ${blockPos.z}`);
                        player.runCommandAsync(`playsound step.grass @s`);
                        player.runCommandAsync(`clear @s bone_meal 0 1`);
                    } else {
                        player.runCommandAsync(`clear @s bone_meal 0 1`);
                    }
                }

                // Crecimiento de Lechuga
                if (block.typeId == lechuga && age < lechugaMaxAge) {
                    if (randomChance < 0.75) {
                        block.setPermutation(block.permutation.withState('tfu:age', age + 1));
                        player.runCommandAsync(`particle minecraft:crop_growth_emitter ${blockPos.x} ${blockPos.y} ${blockPos.z}`);
                        player.runCommandAsync(`playsound step.grass @s`);
                        player.runCommandAsync(`clear @s bone_meal 0 1`);
                    } else {
                        player.runCommandAsync(`clear @s bone_meal 0 1`);
                    }
                }

                // Crecimiento de Maíz
                if (block.typeId == maiz && age < maizMaxAge) {
                    if (randomChance < 0.75) { // Probabilidad del 50%
                        block.setPermutation(block.permutation.withState('tfu:age', age + 1));
                        player.runCommandAsync(`particle minecraft:crop_growth_emitter ${blockPos.x} ${blockPos.y} ${blockPos.z}`);
                        player.runCommandAsync(`playsound step.grass @s`);
                        player.runCommandAsync(`clear @s bone_meal 0 1`);
                    } else {
                        player.runCommandAsync(`clear @s bone_meal 0 1`);
                    }
                }

                // Crecimiento de Tomate
                if (block.typeId == tomate && age < tomateMaxAge - 1) {
                    if (randomChance < 0.75) {
                        block.setPermutation(block.permutation.withState('tfu:age', age + 1));
                        player.runCommandAsync(`particle minecraft:crop_growth_emitter ${blockPos.x} ${blockPos.y} ${blockPos.z}`);
                        player.runCommandAsync(`playsound step.grass @s`);
                        player.runCommandAsync(`clear @s bone_meal 0 1`);
                    } else {
                        player.runCommandAsync(`clear @s bone_meal 0 1`);
                    }
                }
            }
            if (block.typeId == tomate && age === 5) {
                // Establecer el valor 'tfu:age' en 4
                player.runCommandAsync(`playsound step.grass @s`);
                player.runCommandAsync(`loot spawn  ${blockPos.x} ${blockPos.y} ${blockPos.z} loot "blocks/tomate/tomate6"`);
                block.setPermutation(block.permutation.withState('tfu:age', 3));
            }
            if (block.typeId == tomate && age === 6) {
                // Establecer el valor 'tfu:age' en 4
                player.runCommandAsync(`playsound step.grass @s`);
                player.runCommandAsync(`loot spawn  ${blockPos.x} ${blockPos.y} ${blockPos.z} loot "blocks/tomate/tomate7"`);
                block.setPermutation(block.permutation.withState('tfu:age', 3));
            }
        },


        onTick(e) {
            const block = e.block;
            const age = block.permutation.getState('tfu:age');
            const randomChance = Math.random();
            // Crecimiento de Cebolla
            if (block.typeId == cebolla) {
                if (age < cebollaMaxAge) {
                    block.setPermutation(block.permutation.withState('tfu:age', age + 1));
                }
                else if (age == cebollaMaxAge && randomChance < 0.01) {
                    pest(block.location, "tfu:oruga");
                }
            }

            // Crecimiento de Lechuga
            if (block.typeId == lechuga) {

                if (age < lechugaMaxAge) {
                    block.setPermutation(block.permutation.withState('tfu:age', age + 1));
                }
                else if (age == lechugaMaxAge && randomChance < 0.01) {
                    pest(block.location, "tfu:polilla");
                }
            }

            // Crecimiento de Maíz
            if (block.typeId == maiz) {
                block.setPermutation(block.permutation.withState('tfu:age', age + 1));
                if (age < maizMaxAge) {
                    block.setPermutation(block.permutation.withState('tfu:age', age + 1));
                }
                else if (age == maizMaxAge && randomChance < 0.01) {
                    pest(block.location, "tfu:oruga");
                }
            }

            // Crecimiento de Tomate
            if (block.typeId == tomate) {
                block.setPermutation(block.permutation.withState('tfu:age', age + 1));
                if (age < tomateMaxAge) {
                    block.setPermutation(block.permutation.withState('tfu:age', age + 1));
                }
                else if (age == tomateMaxAge && randomChance < 0.01) {
                    pest(block.location, "tfu:snail");
                }
            }
        }
    });
});

//PESTES

function pest(location, entityType) {
    // Define the summon command with the new execute syntax
    let command = `/execute positioned ${location.x + 0.5} ${location.y} ${location.z + 0.5} run summon ${entityType}`;

    // Execute the summon command
    world.getDimension("overworld").runCommand(command);
}


//BONE MEAL

system.runInterval(() => {
    for (const player of world.getPlayers()) {

        player.runCommandAsync("tag @s[hasitem={item=bone_meal, location=slot.weapon.mainhand,quantity=1..}] add bone_meal");
        player.runCommandAsync("tag @s[hasitem={item=bone_meal, location=slot.weapon.mainhand,quantity=0}] remove bone_meal");

    }
}, 2);